#ifndef STA_CORE_YOUR_DEVICE_CUSTOM_PRINTABLE_HPP
#define STA_CORE_YOUR_DEVICE_CUSTOM_PRINTABLE_HPP

#include <sta/config.hpp>

#if defined(STA_PLATFORM_YOUR_DEVICE) || defined(DOXYGEN)

#include <sta/debug/printing/printable.hpp>

namespace sta
{
    /**
     * @brief A custom printable class.
     * 
     * @ingroup sta_core
     */
    class CustomPrintable : public Printable
    {
    public:
        /**
         * @brief Constructor for your custom printable.
         * 
         * Delete if not needed.
         */
        CustomPrintable(/* YOUR ARGMENTS */);

        /**
         * @brief Print string.
         *
         * @param str       String buffer
         * @param length    String length
         */
        void print(const char * str, size_t length) override;
    };
} // namespace sta

#endif // STA_PLATFORM_YOUR_DEVICE

#endif // STA_CORE_YOUR_DEVICE_CUSTOM_PRINTABLE_HPP