#include <sta/bus/i2c/device.hpp>

#include <sta/debug/assert.hpp>


namespace sta
{
    I2CDevice::I2CDevice(I2C * intf, int address, bool master, bool blocking)
        : Device{intf}, intf_{intf}, address_{address}, master_{master}, blocking_{blocking}
    {
        STA_ASSERT(intf != nullptr);
    }

    void I2CDevice::select()
    {
    	// Initialize the interface to match the device's settings.
    	intf_->setSettings(address_, master_, blocking_);
    }

    void I2CDevice::deselect()
    {
    	// Nothing to do here.
    }
} // namespace sta
