#include <sta/debug/assert.hpp>
#ifdef STA_ASSERT_ENABLED

#include <sta/debug/debug.hpp>
#include <sta/lang.hpp>

#include <cstdio>

namespace sta
{
    STA_WEAK
    void assert_failed(const char * expr, const char * file, uint32_t line)
    {
        STA_DEBUG_PRINT(file);
        STA_DEBUG_PRINT(':');
        STA_DEBUG_PRINT(line);
        STA_DEBUG_PRINT(": Assertion failed: ");
        STA_DEBUG_PRINTLN(expr);
    }

    STA_WEAK
    void assert_halt()
    {
        STA_BKPT();
        while (true);
    }
} // namespace sta


#endif // STA_ASSERT_ENABLED
