/*
 * time.cpp
 *
 *  Created on: May 22, 2024
 *      Author: Dario
 */

#include <sta/time.hpp>

#include <sta/config.hpp>
#ifdef STA_PLATFORM_STM32

#include <sta/devices/stm32/hal.hpp>
#include <sta/devices/stm32/clocks.hpp>

namespace sta
{
	uint32_t timeMs()
	{
		return HAL_GetTick();
	}

#ifdef STA_STM32_DELAY_US_TIM
	extern uint32_t gDelayUsMul;

	uint32_t timeUs()
	{
		return __HAL_TIM_GET_COUNTER(&STA_STM32_DELAY_US_TIM) / gDelayUsMul;
	}
#endif // STA_STM32_DELAY_US_TIM
}
#endif // STA_PLATFORM_STM32
